// ---------- Attention: Generated code, please do not modify! -----------  

/*
 * Licensed to the Apache Software Foundation (ASF) under one or more
 * contributor license agreements.  See the NOTICE file distributed with
 * this work for additional information regarding copyright ownership.
 * The ASF licenses this file to You under the Apache License, Version 2.0
 * (the "License"); you may not use this file except in compliance with
 * the License.  You may obtain a copy of the License at
 *
 *      http://www.apache.org/licenses/LICENSE-2.0
 *
 * Unless required by applicable law or agreed to in writing, software
 * distributed under the License is distributed on an "AS IS" BASIS,
 * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 * See the License for the specific language governing permissions and
 * limitations under the License.
 */

package org.apache.myfaces.tobago.component;

import javax.faces.context.FacesContext;
import org.apache.myfaces.tobago.context.Markup;
import org.apache.myfaces.tobago.internal.component.AbstractUICommand;
import org.apache.myfaces.tobago.renderkit.css.CustomClass;
import org.apache.myfaces.tobago.renderkit.css.Style;
import org.apache.myfaces.tobago.internal.util.ArrayUtils;
import org.apache.myfaces.tobago.internal.util.StringUtils;
import org.apache.myfaces.tobago.internal.util.Deprecation;
import javax.el.ELException;
import javax.faces.FacesException;
import java.util.ArrayList;
import java.util.List;
import javax.el.MethodExpression;
import javax.el.ValueExpression;

/** 
 A general command.
  * UIComponent class, generated from template {@code component.stg} with class
  * {@link org.apache.myfaces.tobago.internal.taglib.component.CommandTagDeclaration}.
 */
public class UICommand
    extends AbstractUICommand implements Visual {

  public static final String COMPONENT_TYPE = "org.apache.myfaces.tobago.Command";

  public static final String COMPONENT_FAMILY = "javax.faces.Command";

  private org.apache.myfaces.tobago.context.Markup currentMarkup;

  enum PropertyKeys {
    accessKey,
    markup,
    link,
    resource,
    jsfResource,
    transition,
    label,
    customClass,
    tip,
    style,
    omit,
    target,
    renderedPartially,
    disabled,
  }

  public String getFamily() {
    return COMPONENT_FAMILY;
  }


  /**
  The access key of this control.

  */
  public java.lang.Character getAccessKey() {
    return (java.lang.Character) getStateHelper().eval(PropertyKeys.accessKey);
  }

  public void setAccessKey(java.lang.Character accessKey) {
    getStateHelper().put(PropertyKeys.accessKey, accessKey);
  }

  public org.apache.myfaces.tobago.context.Markup getMarkup() {
    Object object = getStateHelper().eval(PropertyKeys.markup);
    if (object != null) {
      return Markup.valueOf(object);
    }
    return null;
  }

  public void setMarkup(org.apache.myfaces.tobago.context.Markup markup) {
    getStateHelper().put(PropertyKeys.markup, markup);
  }

  /**
  Link to an arbitrary URL, either an internal link or an external link.

   <dl>
     <dt>internal absolute link</dt>
     <dd>Starts with a slash '/' character. The context path will be added.
         A session id will be added, if needed.</dd>
     <dt>external link</dt>
     <dd>Starts with protocol followed by a colon ':' character.
         The link will not be modified.</dd>
     <dt>internal relative link</dt>
     <dd>Any other strings. A session id will be added, if needed.</dd>
   </dl>

  */
  public java.lang.String getLink() {
    return (java.lang.String) getStateHelper().eval(PropertyKeys.link);
  }

  public void setLink(java.lang.String link) {
    getStateHelper().put(PropertyKeys.link, link);
  }

  /**
  Link to an internal resource.
   Resources will be processed by the resource management.
   E. g. define help.html and it will be served help_es.html or help_de.html if available.
   For JSF-Pages you have to set the jsfResource attribute.

  */
  public java.lang.String getResource() {
    return (java.lang.String) getStateHelper().eval(PropertyKeys.resource);
  }

  public void setResource(java.lang.String resource) {
    getStateHelper().put(PropertyKeys.resource, resource);
  }

  /**
  Flag indicating that the resource referenced by the resource attribute is a jsf resource.
   That means that the url has to be processed to change the prefix or suffix (e. g. *.jsf or
   /faces/*). Default is false.
  <br />Default: <code>false</code>
  */
  public boolean isJsfResource() {
    Boolean bool = (Boolean) getStateHelper().eval(PropertyKeys.jsfResource);
    if (bool != null) {
      return bool;
    }
    return false;
  }

  public void setJsfResource(boolean jsfResource) {
    getStateHelper().put(PropertyKeys.jsfResource, jsfResource);
  }

  /**
  Specify, if the command calls an JSF-Action.
   Useful to switch off the Double-Submit-Check and Waiting-Behavior.
  <br />Default: <code>true</code>
  */
  public boolean isTransition() {
    Boolean bool = (Boolean) getStateHelper().eval(PropertyKeys.transition);
    if (bool != null) {
      return bool;
    }
    return true;
  }

  public void setTransition(boolean transition) {
    getStateHelper().put(PropertyKeys.transition, transition);
  }

  /**
  Text value to display as label.
   If text contains an underscore the next character is used as accesskey (if configured so and possible).

  */
  public java.lang.String getLabel() {
    return (java.lang.String) getStateHelper().eval(PropertyKeys.label);
  }

  public void setLabel(java.lang.String label) {
    getStateHelper().put(PropertyKeys.label, label);
  }

  /**
  Sets a CSS class in its parent, if the parent supports it.

   Which this feature it is possible to put a CSS class name into a component with the <tc:style> tag. Example:

   <pre>
   &lt;tc:in>
     &lt;tc:style customClass="my-emphasized"/>
   &lt;/tc:in>
   </pre>

   One capability is, to used external CSS libs.
   <br/>
   This feature should not be used imprudent.
   Because it might be unstable against changes in the renderered HTML code.

  */
  public org.apache.myfaces.tobago.renderkit.css.CustomClass getCustomClass() {
    return (org.apache.myfaces.tobago.renderkit.css.CustomClass) getStateHelper().eval(PropertyKeys.customClass);
  }

  public void setCustomClass(org.apache.myfaces.tobago.renderkit.css.CustomClass customClass) {
    getStateHelper().put(PropertyKeys.customClass, customClass);
  }

  /**
  Text value to display as tooltip.

  */
  public java.lang.String getTip() {
    return (java.lang.String) getStateHelper().eval(PropertyKeys.tip);
  }

  public void setTip(java.lang.String tip) {
    getStateHelper().put(PropertyKeys.tip, tip);
  }

  /**
  For internal use. Used for rendering, if there is a child tag &lt;tc:style>

  */
  public org.apache.myfaces.tobago.renderkit.css.Style getStyle() {
    return (org.apache.myfaces.tobago.renderkit.css.Style) getStateHelper().eval(PropertyKeys.style);
  }

  public void setStyle(org.apache.myfaces.tobago.renderkit.css.Style style) {
    getStateHelper().put(PropertyKeys.style, style);
  }

  /**
  Flag indicating that the action of this element, will not be executed from client side
   (e. g. when the user clicks a button.
   When setting this value to true, the action will not be executed by the Tobago, but it can executed
   by JavaScript.
   This attribute is useful, when you want to add JavaScript event handlers to commands manually.
   In this case you usually don't want a submit with a full reload of the page.
  <br />Default: <code>false</code>
  */
  public boolean isOmit() {
    Boolean bool = (Boolean) getStateHelper().eval(PropertyKeys.omit);
    if (bool != null) {
      return bool;
    }
    return false;
  }

  public void setOmit(boolean omit) {
    getStateHelper().put(PropertyKeys.omit, omit);
  }

  public org.apache.myfaces.tobago.context.Markup getCurrentMarkup() {
    if (currentMarkup != null) {
      return currentMarkup;
    }
    return null;
  }

  public void setCurrentMarkup(org.apache.myfaces.tobago.context.Markup currentMarkup) {
    this.currentMarkup = currentMarkup;
  }

  /**
  Name of a frame where the resource retrieved via this hyperlink is to be
   displayed.

  */
  public java.lang.String getTarget() {
    return (java.lang.String) getStateHelper().eval(PropertyKeys.target);
  }

  public void setTarget(java.lang.String target) {
    getStateHelper().put(PropertyKeys.target, target);
  }

  /**
  <p>
   Indicate the partially rendered components in a case of a submit.
   </p>
   <p>
   The search depends on the number of prefixed colons in the relativeId:
   <dl>
     <dd>number of prefixed colons == 0</dd>
     <dt>fully relative</dt>
     <dd>number of prefixed colons == 1</dd>
     <dt>absolute (still normal findComponent syntax)</dt>
     <dd>number of prefixed colons == 2</dd>
     <dt>search in the current naming container (same as 0 colons)</dt>
     <dd>number of prefixed colons == 3</dd>
     <dt>search in the parent naming container of the current naming container</dt>
     <dd>number of prefixed colons > 3</dd>
     <dt>go to the next parent naming container for each additional colon</dt>
   </dl>
   </p>
   <p>
   If a literal is specified: to use more than one identifier the identifiers must be space delimited.
   </p>
   <p>
   Using this in a UISheet or UITabGroup component this list indicates components to update when calling
   internal AJAX requests like sort or paging commands.
   Don't forget to add the sheet-id or tagGroup-id in that case, if needed.
   </p>
   <p>
   You can also use

  */
  public String[] getRenderedPartially() {
    Object strArray = getStateHelper().eval(PropertyKeys.renderedPartially);
    if (strArray != null) {
      if (strArray instanceof String[]) {
        return (String[]) strArray;
      } else if (strArray instanceof String) {
        String[] strings = StringUtils.split((String) strArray, ", ");
        List<String> result = new ArrayList<String>(strings.length);
        for (String string : strings) {
          if (string.trim().length() != 0) {
            result.add(string.trim());
          }
        }
        return result.toArray(new String[result.size()]);
      } else if (strArray == null) {
        return org.apache.myfaces.tobago.internal.util.ArrayUtils.EMPTY_STRING_ARRAY;
      } else {
        return new String[]{strArray.toString()};
      }
    }
    return org.apache.myfaces.tobago.internal.util.ArrayUtils.EMPTY_STRING_ARRAY;
  }

  public void setRenderedPartially(String[] renderedPartially) {
    getStateHelper().put(PropertyKeys.renderedPartially, renderedPartially);
  }

  /**
  Flag indicating that this element is disabled.
  <br />Default: <code>false</code>
  */
  public boolean isDisabled() {
    Boolean bool = (Boolean) getStateHelper().eval(PropertyKeys.disabled);
    if (bool != null) {
      return bool;
    }
    return false;
  }

  public void setDisabled(boolean disabled) {
    getStateHelper().put(PropertyKeys.disabled, disabled);
  }

  public Object saveState(FacesContext context) {
    currentMarkup = null;
    return super.saveState(context);
  }

}