// ---------- Attention: Generated code, please do not modify! -----------  

/*
 * Licensed to the Apache Software Foundation (ASF) under one or more
 * contributor license agreements.  See the NOTICE file distributed with
 * this work for additional information regarding copyright ownership.
 * The ASF licenses this file to You under the Apache License, Version 2.0
 * (the "License"); you may not use this file except in compliance with
 * the License.  You may obtain a copy of the License at
 *
 *      http://www.apache.org/licenses/LICENSE-2.0
 *
 * Unless required by applicable law or agreed to in writing, software
 * distributed under the License is distributed on an "AS IS" BASIS,
 * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 * See the License for the specific language governing permissions and
 * limitations under the License.
 */

package org.apache.myfaces.tobago.component;

import javax.faces.application.FacesMessage;
import javax.faces.context.FacesContext;
import org.apache.myfaces.tobago.context.Markup;
import org.apache.myfaces.tobago.internal.component.AbstractUIMessages;
import org.apache.myfaces.tobago.layout.OrderBy;
import org.apache.myfaces.tobago.renderkit.css.CustomClass;
import org.apache.myfaces.tobago.renderkit.css.Style;
import org.apache.myfaces.tobago.internal.util.ArrayUtils;
import org.apache.myfaces.tobago.internal.util.StringUtils;
import org.apache.myfaces.tobago.internal.util.Deprecation;
import javax.el.ELException;
import javax.faces.FacesException;
import java.util.ArrayList;
import java.util.List;
import javax.el.MethodExpression;
import javax.el.ValueExpression;

/** 
 Renders error/validation messages.
  * UIComponent class, generated from template {@code component.stg} with class
  * {@link org.apache.myfaces.tobago.internal.taglib.component.MessagesTagDeclaration}.
 */
public class UIMessages
    extends AbstractUIMessages implements Visual {

  public static final String COMPONENT_TYPE = "org.apache.myfaces.tobago.Messages";

  public static final String COMPONENT_FAMILY = "javax.faces.Messages";

  private org.apache.myfaces.tobago.context.Markup currentMarkup;

  enum PropertyKeys {
    markup,
    globalOnly,
    orderBy,
    customClass,
    maxSeverity,
    minSeverity,
    style,
    confirmation,
    maxNumber,
  }

  public String getFamily() {
    return COMPONENT_FAMILY;
  }


  public org.apache.myfaces.tobago.context.Markup getMarkup() {
    Object object = getStateHelper().eval(PropertyKeys.markup);
    if (object != null) {
      return Markup.valueOf(object);
    }
    return null;
  }

  public void setMarkup(org.apache.myfaces.tobago.context.Markup markup) {
    getStateHelper().put(PropertyKeys.markup, markup);
  }

  /**
  Flag indicating that only messages that are not associated to any
   particular UIComponent should be displayed. That are messages without clientId.
  <br />Default: <code>false</code>
  */
  public java.lang.String getGlobalOnly() {
    java.lang.String globalOnly = (java.lang.String) getStateHelper().eval(PropertyKeys.globalOnly);
    if (globalOnly != null) {
      return globalOnly;
    }
    return "false";
  }

  public void setGlobalOnly(java.lang.String globalOnly) {
    getStateHelper().put(PropertyKeys.globalOnly, globalOnly);
  }

  /**
  Sets the order of the messages.
  <br />Default: <code>occurrence</code><br />Allowed Values: <code>occurrence,severity</code>
  */
  public org.apache.myfaces.tobago.layout.OrderBy getOrderBy() {
    org.apache.myfaces.tobago.layout.OrderBy orderBy = (org.apache.myfaces.tobago.layout.OrderBy) getStateHelper().eval(PropertyKeys.orderBy);
    if (orderBy != null) {
      return orderBy;
    }
    return org.apache.myfaces.tobago.layout.OrderBy.occurrence;
  }

  public void setOrderBy(org.apache.myfaces.tobago.layout.OrderBy orderBy) {
    getStateHelper().put(PropertyKeys.orderBy, orderBy);
  }

  /**
  Sets a CSS class in its parent, if the parent supports it.

   Which this feature it is possible to put a CSS class name into a component with the <tc:style> tag. Example:

   <pre>
   &lt;tc:in>
     &lt;tc:style customClass="my-emphasized"/>
   &lt;/tc:in>
   </pre>

   One capability is, to used external CSS libs.
   <br/>
   This feature should not be used imprudent.
   Because it might be unstable against changes in the renderered HTML code.

  */
  public org.apache.myfaces.tobago.renderkit.css.CustomClass getCustomClass() {
    return (org.apache.myfaces.tobago.renderkit.css.CustomClass) getStateHelper().eval(PropertyKeys.customClass);
  }

  public void setCustomClass(org.apache.myfaces.tobago.renderkit.css.CustomClass customClass) {
    getStateHelper().put(PropertyKeys.customClass, customClass);
  }

  /**
  Sets the maximum severity to be shown. E. g. "warn" shows only "warn" and "info".
   When setting this attribute you usually shoud take care, that you have a second message tag to show the
   higher severity levels.
  <br />Default: <code>fatal</code>
  */
  public javax.faces.application.FacesMessage.Severity getMaxSeverity() {
    javax.faces.application.FacesMessage.Severity maxSeverity = (javax.faces.application.FacesMessage.Severity) getStateHelper().eval(PropertyKeys.maxSeverity);
    if (maxSeverity != null) {
      return maxSeverity;
    }
    return javax.faces.application.FacesMessage.SEVERITY_FATAL;
  }

  public void setMaxSeverity(javax.faces.application.FacesMessage.Severity maxSeverity) {
    getStateHelper().put(PropertyKeys.maxSeverity, maxSeverity);
  }

  /**
  Sets the mininum severity to be shown. E. g. "warn" shows only "warn", "error" and "fatal".
  <br />Default: <code>info</code>
  */
  public javax.faces.application.FacesMessage.Severity getMinSeverity() {
    javax.faces.application.FacesMessage.Severity minSeverity = (javax.faces.application.FacesMessage.Severity) getStateHelper().eval(PropertyKeys.minSeverity);
    if (minSeverity != null) {
      return minSeverity;
    }
    return javax.faces.application.FacesMessage.SEVERITY_INFO;
  }

  public void setMinSeverity(javax.faces.application.FacesMessage.Severity minSeverity) {
    getStateHelper().put(PropertyKeys.minSeverity, minSeverity);
  }

  /**
  For internal use. Used for rendering, if there is a child tag &lt;tc:style>

  */
  public org.apache.myfaces.tobago.renderkit.css.Style getStyle() {
    return (org.apache.myfaces.tobago.renderkit.css.Style) getStateHelper().eval(PropertyKeys.style);
  }

  public void setStyle(org.apache.myfaces.tobago.renderkit.css.Style style) {
    getStateHelper().put(PropertyKeys.style, style);
  }

  /**
  Has the user to confirm this message?
   This attributes handles the case, if the application wants to warn the user about a problem,
   and the user has to confirm the message before he/she can continue.
  <br />Default: <code>false</code>
  */
  public boolean isConfirmation() {
    Boolean bool = (Boolean) getStateHelper().eval(PropertyKeys.confirmation);
    if (bool != null) {
      return bool;
    }
    return false;
  }

  public void setConfirmation(boolean confirmation) {
    getStateHelper().put(PropertyKeys.confirmation, confirmation);
  }

  public org.apache.myfaces.tobago.context.Markup getCurrentMarkup() {
    if (currentMarkup != null) {
      return currentMarkup;
    }
    return null;
  }

  public void setCurrentMarkup(org.apache.myfaces.tobago.context.Markup currentMarkup) {
    this.currentMarkup = currentMarkup;
  }

  /**
  Sets the maximum number of messages to show.
  <br />Default: <code>2147483647</code>
  */
  public java.lang.Integer getMaxNumber() {
    Number value  = (Number) getStateHelper().eval(PropertyKeys.maxNumber);
    if (value != null) {
      return value.intValue();
    }
    return 2147483647;
  }

  public void setMaxNumber(java.lang.Integer maxNumber) {
    getStateHelper().put(PropertyKeys.maxNumber, maxNumber);
  }

  public Object saveState(FacesContext context) {
    currentMarkup = null;
    return super.saveState(context);
  }

}